package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;
import java.util.List;

public class ExampleMain {
    private static EntityManagerFactory entityManagerFactory =
            Persistence.createEntityManagerFactory("example-unit");

    public static void main(String[] args) {
        try {
            persistArticle();
            updateArticle();
            loadArticles();
        } finally {
            entityManagerFactory.close();
        }
    }

    public static void persistArticle() {
        System.out.println("-- persisting --");
        Article article = new Article();
        article.setContent("some test content");
        EntityManager em = entityManagerFactory.createEntityManager();
        em.getTransaction().begin();
        em.persist(article);
        em.getTransaction().commit();
        em.close();
        System.out.println("Article persisted: " + article);
    }

    public static void updateArticle() {
        System.out.println("-- loading and updating --");
        EntityManager em = entityManagerFactory.createEntityManager();
        Article article = em.find(Article.class, 1);
        em.getTransaction().begin();
        article.setContent("new updated content");
        em.getTransaction().commit();
        em.close();
        System.out.println("Article updated: " + article);
    }

    private static void loadArticles() {
        System.out.println("-- loading --");
        EntityManager em = entityManagerFactory.createEntityManager();
        Query query = em.createQuery("SELECT t FROM Article t");
        List<Article> resultList = query.getResultList();
        resultList.forEach(System.out::println);
    }
}